﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.5
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private NH As NativeHook
	
	Private mMainForm As Form
	Private mModule As Object
	Public MouseListenerPaused As Boolean
	Private MouseButtonsDown As Int
	Private TH As Thread						'ignore
End Sub


Sub Initialize(Module As Object,MainForm As Form)
	
	mModule = Module
	mMainForm = MainForm
	TH.Initialise("TH")			'Initialize a Thread Object so we can pass data to the Gui Thread
	NH.Initialize("NH", Me)     'Initializes and registers the NativeHook
	NH.startNativeMouseMotionListener
	NH.startNativeMouseInputListener
	NH.EnableEventConsumption  	'Allows you to consume input events
	
End Sub


Public Sub NH_NativeMouseMoved(nme As NativeMouseEvent) As Boolean
	If OverWindow(nme) Then
		Log((nme.X - mMainForm.WindowLeft) & ", " & (nme.Y - mMainForm.WindowTop))
	End If
	Return False
End Sub

Private Sub OverWindow(nme As NativeMouseEvent) As Boolean

	If nme.X >= mMainForm.WindowLeft And _
	nme.X <= mMainForm.WindowLeft + mMainForm.WindowWidth And _
	nme.Y >= mMainForm.WindowTop And _
	nme.Y <= mMainForm.WindowTop + mMainForm.WindowHeight Then
		Return True
	Else
		Return False
	End If
End Sub


Public Sub IsPaused As Boolean
	Return MouseListenerPaused
End Sub

Public Sub Pause
	NH.endNativeMouseInputListener
	NH.endNativeKeyListener
	MouseListenerPaused = True
End Sub

Public Sub ReStart
	If MouseListenerPaused Then
		NH.startNativeMouseInputListener
		NH.startNativeKeyListener
		MouseListenerPaused = False
	End If
End Sub

'Allow stopping listeners
Public Sub Stop
	NH.endNativeMouseInputListener
	NH.endNativeKeyListener
	NH.unregisterNativeHook
End Sub

'Event fired when the NativeHook is unregistered
'Sub needs to be here or an error is thrown by the library, it is used will depend on the application.
'This application only unregisters the listener when it closes so we don't need to do anything.
Private Sub NH_Unregistered
'	ExitApplication
End Sub

'Sub to handle Mouse Pressed call from the Native hook
Private Sub NH_NativeMousePressed(nme As NativeMouseEvent) As Boolean		'ignore
	MouseButtonDown(nme.MouseButton)
	TH.RunOnGuiThread("Mouse_Action",Array(nme,True))
	Return False
End Sub

'Sub to handle Mouse Released call from the Native hook
Private Sub NH_NativeMouseReleased(nme As NativeMouseEvent) As Boolean		
	TH.RunOnGuiThread("Mouse_Action",Array(nme,False))
	MouseButtonUp(nme.MouseButton)
	Return False
End Sub

Private Sub MouseButtonDown(Button As Int)
	MouseButtonsDown = Bit.Or(MouseButtonsDown,Bit.ShiftLeft(1,Button))
End Sub
Private Sub MouseButtonUp(Button As Int)
	MouseButtonsDown = Bit.And(MouseButtonsDown,Bit.Not(Bit.ShiftLeft(1,Button)))
End Sub

Private Sub Mouse_Action(nme As NativeMouseEvent, Pressed As Boolean)
	Log(nme.MouseButton)
	If SubExists(mModule,"NativeHookStatic_MouseAction") Then
		CallSub3(mModule,"NativeHookStatic_MouseAction",nme, Pressed)
	End If
End Sub